<template>
  <div :class="['album-list-item-galleryview', { 'album-list-item-galleryview--active': active }]">
    <div v-if="!managing" class="album-list-item-galleryview__thumb">
      <router-link :to="route" v-long-press="onLongPress">
        <img :src="thumb" :alt="album.displayName" :title="album.displayName" />
      </router-link>
    </div>
    <div
      v-if="managing"
      :class="{
        'album-list-item-galleryview__thumb': true,
        'album-list-item-galleryview__thumb--managing': !active,
        'album-list-item-galleryview__thumb--managing-selected': active,
      }"
      @click="onClickWhenManaging"
    >
      <img :src="thumb" :alt="album.displayName" :title="album.displayName" />
    </div>
    <div class="album-list-item-galleryview__link">
      <router-link :to="route">{{ album.displayName }}</router-link>
    </div>
  </div>
</template>

<script>
const NO_IMAGE_THUMB = '/images/layout/no-image.png'

import { computed } from 'vue'
import { useApi } from '../../core'
import ImageHelper from '../lib/image-helper.js'

export default {
  name: 'AlbumsListItemGalleryView',
  emits: ['albumLongPress', 'albumSelected'],
  props: {
    album: { type: Object, required: true },
    active: { type: Boolean, default: false },
    managing: { type: Boolean, default: false },
    selecting: { type: Boolean, default: false },
  },
  setup(props, context) {
    const api = useApi()

    const thumb = computed(() => {
      return props.album.image
        ? ImageHelper.getImageUrl(api.storageBaseUrl, props.album.image, 'thumb')
        : NO_IMAGE_THUMB
    })

    const route = computed(() => {
      return props.album?.user
        ? {
            name: 'gallery-images',
            params: { username: props.album.user.username, alias: props.album.alias },
            query: { selecting: props.selecting ? 'true' : undefined },
          }
        : null
    })

    const onLongPress = () => {
      context.emit('albumLongPress', props.album)
      context.emit('albumSelected', props.album)
    }

    const onClickWhenManaging = () => {
      context.emit('albumSelected', props.album)
    }

    return {
      thumb,
      route,
      onLongPress,
      onClickWhenManaging,
    }
  },
}
</script>

<style lang="scss">
@use '../../core/sass/vars';

.album-list-item-galleryview {
  width: vars.$galleryThumbWidth;
  float: left;
  margin-right: vars.$gallerySpacing;
  margin-bottom: vars.$gallerySpacing;
}

.album-list-item-galleryview__thumb {
  img {
    width: vars.$galleryThumbWidth;
    height: vars.$galleryThumbWidth;
    border-radius: vars.$galleryBorderRadius;
  }
}

.album-list-item-galleryview__thumb--managing {
  img {
    box-sizing: content-box;
    border: vars.$managingBorderWidth solid vars.$panelColor;
    border-radius: vars.$managingBorderRadius;
    width: vars.$galleryThumbWidth - vars.$managingBorderWidth * 2;
    height: vars.$galleryThumbWidth - vars.$managingBorderWidth * 2;
  }
}

.album-list-item-galleryview__thumb--managing-selected {
  img {
    box-sizing: content-box;
    border: vars.$managingSelectedBorderWidth solid vars.$linkColor;
    border-radius: vars.$managingBorderRadius;
    width: vars.$galleryThumbWidth - vars.$managingSelectedBorderWidth * 2;
    height: vars.$galleryThumbWidth - vars.$managingSelectedBorderWidth * 2;
  }
}

.album-list-item-galleryview__link {
  text-align: center;
  overflow: hidden;
}

.album-list-item-galleryview__link > a {
  text-decoration: none;
  color: vars.$textColor;

  &:hover {
    color: vars.$textColor;
    text-decoration: none;
  }
}

// Larger displays
@media only screen and (min-width: vars.$sm) {
  .album-list-item-galleryview {
    width: vars.$galleryThumbWidthLarge;
    margin-right: vars.$gallerySpacingLarge;
    margin-bottom: vars.$gallerySpacingLarge;
  }

  .album-list-item-galleryview__thumb {
    img {
      width: vars.$galleryThumbWidthLarge;
      height: vars.$galleryThumbWidthLarge;
      background-color: vars.$panelColor;
      border-radius: vars.$galleryBorderRadiusLarge;
    }
  }

  .album-list-item-galleryview__thumb--managing {
    img {
      box-sizing: content-box;
      border: vars.$managingBorderWidth solid vars.$panelColor;
      border-radius: vars.$managingBorderRadius;
      width: vars.$galleryThumbWidthLarge - vars.$managingBorderWidth * 2;
      height: vars.$galleryThumbWidthLarge - vars.$managingBorderWidth * 2;
    }
  }

  .album-list-item-galleryview__thumb--managing-selected {
    img {
      box-sizing: content-box;
      border: vars.$managingSelectedBorderWidth solid vars.$linkColor;
      border-radius: vars.$managingBorderRadius;
      width: vars.$galleryThumbWidthLarge - vars.$managingSelectedBorderWidth * 2;
      height: vars.$galleryThumbWidthLarge - vars.$managingSelectedBorderWidth * 2;
    }
  }
}

.dark {
  .album-list-item-galleryview__link > a {
    color: vars.$darkTextColor;

    &:hover {
      color: vars.$darkTextColor;
    }
  }

  .album-list-item-galleryview__thumb {
    img {
      background-color: vars.$darkPanelColor;
    }
  }

  .album-list-item-galleryview__thumb--managing img {
    border-color: vars.$darkPanelColor;
  }

  .album-list-item-galleryview__thumb-selected img {
    border-color: vars.$darkLinkColor;
  }
}
</style>
